/* Chunk is FIFO buffer designed for recieving data in chunks and allowing it
   to be read in dribs and drabs.
   Each block of data is malloc'ed memory which goes in a linked list.
   
   Data may be read from Chunk upto LeadSz using the char * returned by Chunk
   lead, but you must then 'consume' those bytes before getting a pointer to
   the next chunk.
   
   The MoveTo function will write data from a Chunk to a char* without limits
   */

#ifndef CHUNK_H
#define CHUNK_H

#include "sys/types.h"

struct chunk{
    size_t sz;
	struct chunk *next;
};

typedef struct{
        
        struct chunk *first,*last;
		size_t grosstote;
		size_t nettote;
		size_t consumed;
}Chunk;

Chunk *MakeChunk();
int ChunkAdd(Chunk *ch,char *src,size_t sz);
size_t ChunkGrossSize(Chunk *ch);
size_t ChunkNettSize(Chunk *ch);
size_t ChunkLeadSz(Chunk *ch);
void ChunkConsume(Chunk *ch,size_t sz);
char *ChunkLead(Chunk *ch);
size_t ChunkMoveTo(Chunk *ch,char *dest,size_t max);
void ChunkDestroy(Chunk *ch);

#endif
